/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
const Cc = Components.classes;
const Ci = Components.interfaces;

function OBM_AddressBook_Contact_AutoSynchronize () {
  this.interval = null;
  
  var scriptLoader = Cc["@mozilla.org/moz/jssubscript-loader;1"].createInstance(Ci.mozIJSSubScriptLoader);
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/UtilsOBM.js");

  var g_prefService=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var g_Prefs=g_prefService.getBranch(null);
  if (UtilsOBM.isPrefExist("extensions.obm.contact.autorefresh.timeout")) {
		var inter = UtilsOBM.getIntPref("extensions.obm.contact.autorefresh.timeout");
		if ( inter && inter != "" && inter > 0 ) {
		  this.interval = inter * 60 * 1000;
		}
  }  

  if ( this.interval == null) {
		// sync auto not enabled
		return;
  }

  this.mRefreshTimer = null;
  this.setUpRefreshTimer();
}

OBM_AddressBook_Contact_AutoSynchronize.prototype = {
  setUpRefreshTimer: function obmas_setUpRefreshTimer() {
		this.mRefreshTimer = Components.classes["@mozilla.org/timer;1"]
		  .createInstance(Components.interfaces.nsITimer);
		this.mRefreshTimer.init(this, this.interval, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
  },
  
  observe: function obmas_observe(aSubject, aTopic, aData) {
    if (aTopic == 'timer-callback') {
		if ( !UtilsOBM.isOnline() ) {
			this.logger.debug("refresh canceled: we're offline", false, false);
			return ;
		}
      var wWatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
      var window = wWatcher.getWindowByName("OBM_SYNCHRO", null);
      if (window != null) {
	      this.logger.debug("refresh canceled : sync window open", false, false);
	      return;
      }
      
      var syncManager = Components.classes["@obm.org/syncmanager;1"].createInstance(Components.interfaces.obmISyncManager);
      syncManager.syncAddressBook();
      
      this.mRefreshTimer.cancel();
      this.mRefreshTimer.init(this, this.directories[this.currentIndex].timeout, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	
      this.currentIndex += 1;
      this.currentIndex = this.currentIndex % this.directories.length;
    } else if (aTopic == 'nsPref:changed') {
    }
  }
}

var timer = new OBM_AddressBook_Contact_AutoSynchronize;

// */
