
/* ***** BEGIN LICENSE BLOCK *****
 *
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  http://www.obm.org/
 *
 * ***** END LICENSE BLOCK ***** */


function CalendarShell(aXml) {
	this._mXml = aXml;
}

CalendarShell.prototype = {
	/*<info>
		<first>user3</first>
		<last>user3</last>
		<mail>user3@dom1.local</mail>
		<uid>user3</uid>
		<read>true</read>
		<write>true</write>
	</info>*/
	get uid() {return _xS(this._mXml.*::uid)},
	get firstname() {return _xS(this._mXml.*::first)},
	get lastname() {return _xS(this._mXml.*::last)},
	get mail() {return _xS(this._mXml.*::mail)},
	get read() {return _xB(this._mXml.*::read)},
	get write() {return _xB(this._mXml.*::write)}
};


function CalendarArrayShell(aXml) {
	this.list = aXml.*::info;
}

CalendarArrayShell.prototype = {
	get length() {return this.list.length();},
	getElementAt: function(idx) {
		return new CalendarShell(this.list[idx]);
	}	
}


function ObmRAttendee(email, displayName, status, type, isOrganizer) {
	this._email = email;
	this._displayName = displayName;
	this._status = status;
	this._type = type;
	this._isOrganizer = isOrganizer;
}
ObmRAttendee.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIRAttendee)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	get email () { return this._email;},
	get displayName () { return this._displayName;},
	get status () { return this._status;},
	set status (val) { this._status = val;},
	get type () { return this._type;},
	get isOrganizer () { return this._isOrganizer;}
}



function ParticipationChangeShell(aXml) {
	this._mXml = aXml;
	this._attendees = null; // cache for attendees
}

ParticipationChangeShell.prototype = {
	QueryInterface: function(aIID) {
			if (!aIID.equals(Ci.nsISupports) &&
					!aIID.equals(Ci.obmIRParticipationChange)) {
					throw Cr.NS_ERROR_NO_INTERFACE;
			}
			return this;
	},
	_readAttendees : function() {
		this._attendees = [];
		if (this._mXml.*::attendees) {
			for each( var att in this._mXml.*::attendees.*) {
				var attendee = new ObmRAttendee(_xS(att.@email),
												_xS(att.@displayName),
												_xS(att.@state),
												_xS(att.@required),
												_xB(att.@isOrganizer));
				this._attendees.push(attendee);
			}
		}
	},
	get uid() {return _xS(this._mXml.@id)},
	get generation() {return this._mXml.@sequence ? _xL(this._mXml.@sequence) : 0 },
	get extId() {return _xS(this._mXml.@extId)},
	getAttendees: function(count) {
		if (this._attendees === null) {
			this._readAttendees();
		}
		count.value = this._attendees.length;
		return this._attendees;
	},

	getAttendeeByEmail : function(email) {
		if (this._attendees === null) {
			this._readAttendees();
		}
		for(var i=0; i < this._attendees.length; i++) {
			if (this._attendees[i].email.toLowerCase() == email.toLowerCase())
				return this._attendees[i];
		}
		return null;
	}
};

function EventShell(aXml) {
	this._mXml = aXml;
	this._attendees = null; // cache for attendees
}

EventShell.prototype = {
	QueryInterface: function(aIID) {
		if (!aIID.equals(Ci.nsISupports) &&
			!aIID.equals(Ci.obmIREventRecurrence) &&
			!aIID.equals(Ci.obmIREvent)) {
			throw Cr.NS_ERROR_NO_INTERFACE;
		}
		return this;
	},
	_readAttendees : function() {
		this._attendees = [];
		if (this._mXml.*::attendees) {
			for each( var att in this._mXml.*::attendees.*) {
				var attendee = new ObmRAttendee(_xS(att.@email),
												_xS(att.@displayName),
												_xS(att.@state),
												_xS(att.@required),
												_xB(att.@isOrganizer));
				this._attendees.push(attendee);
			}
		}
	},
	// obmIREvent
	get uid() {return _xS(this._mXml.@id);},
	get extId() {return _xS(this._mXml.*::extId);},
	get generation() {return this._mXml.@sequence ?  _xL(this._mXml.@sequence)  : 0; },
	get recurrenceId() {return _xS(this._mXml.*::recurrenceId)},
	get owner() {return _xS(this._mXml.*::owner)},
	get ownerEmail() {return _xS(this._mXml.*::ownerEmail)},
	get priority() {return _xL(this._mXml.*::priority)},
	get privacy() {return _xL(this._mXml.*::privacy)},
	get allday() {return _xB(this._mXml.@allDay)},
	get date() {return _xS(this._mXml.*::date)},
	get duration() {return _xL(this._mXml.*::duration)},
	get title() {return _xS(this._mXml.*::title)},
	get description() {return _xS(this._mXml.*::description)},
	get category() {return _xS(this._mXml.*::category)},
	get location() {return _xS(this._mXml.*::location)},
	get opacity() {return _xS(this._mXml.*::opacity)},
	get recurrence() {return this;},
	getAttendees: function(count) {
		if (this._attendees === null) {
			this._readAttendees();
		}
		count.value = this._attendees.length;
		return this._attendees;
	},

	getAttendeeByEmail : function(email) {
		if (this._attendees === null) {
			this._readAttendees();
		}
		for(var i=0; i < this._attendees.length; i++) {
			if (this._attendees[i].email.toLowerCase() == email.toLowerCase())
				return this._attendees[i];
		}
		return null;
	},

	// obmIREventRecurrence
	get kind() {return _xS(this._mXml.*::recurrence.@kind)},
	get frequence() {return _xL(this._mXml.*::recurrence.@freq)},
	get days() {return _xS(this._mXml.*::recurrence.@days)},
	get end() {return _xS(this._mXml.*::recurrence.@end)},
	getExceptions: function(count) {
		var exceptions = [];
		var exs = this._mXml.*::recurrence.*::exceptions.*::exception.*;
		for each (var ex in exs) {
			exceptions.push(_xS(ex));
		}
		if (exceptions.length > 0) {
			count.value = exceptions.length;
			return exceptions;
		} else {
			return;
		}
	},
	getEventExceptions: function(count) {
	  var eventExceptions  = [];
	  var eventExs = this._mXml.*::recurrence.*::eventExceptions.*;
	  for each (var eventEx in eventExs) {
		  eventExceptions.push(new EventShell(eventEx));
	  }
	  if (eventExceptions.length > 0) {
		  count.value = eventExceptions.length;
		  return eventExceptions;
	  } else {
		  return;
	  }
	},
	get alert() {return _xL(this._mXml.*::alert, -1)},
	get isInternal() {return (this._mXml.@isInternal == 'true');}
};

function GetSyncEventWithSortedChangesResponseShell(aXml) {
	this._updated = [];
	this._removed = [];
	this._participationChanged = [];
	this._removedExtId = [];
	this._lastSync = aXml.@lastSync.toString();

	for each (var updated in aXml.*::updated.*) {
	    if ( (updated.*::recurrenceId == undefined) || (updated.*::recurrenceId == 0)) {
		  this._updated.push(new EventShell(updated));
		} else {
		  //skip this is an eventException allready in parent item
		}
	}

	for each (var removed in aXml.*::removed.*) {
		this._removed.push(removed.@id.toString());
		if (removed.@extId != undefined) {
			this._removedExtId.push(removed.@extId.toString());
		}
	}

	for each (var participationChange in aXml.*::participationChanges.*) {
		this._participationChanged.push(new ParticipationChangeShell(participationChange));
	}


	/*
	<calendar-changes lastSync="20081127230000000" xmlns="http://www.obm.org/xsd/sync/calendar-changes.xsd">
		<participation-changes>
			<participation extId="966c71d7-04d0-4551-85b7-c9641e20f1d6" id="26">
			<attendees>
				<attendee email="blum@obm.matthieu.lng" state="ACCEPTED"/>
				<attendee email="jaures@obm.matthieu.lng" state="ACCEPTED"/>
			</attendees>
			</participation>
		</participation-changes>
		<removed>
			<event id="user3-2" extId="85f148ae-2400-4860-b1dd-ae3fa062b07b"/>
			<event id="user3-3" extId="e1e253f9-b7a6-488b-a360-5ca294afb803"/>
			<event id="user3-4" extId="ad3f09e7-1a5e-40c2-ae1d-12906fbc3760"/>
			<event id="user3-5" extId="e19991ea-8131-4b61-88fe-e25b84311073"/>
		</removed>
		<updated>
			<event id="1">
			<title>eeeeee</title>
			<owner>user3</owner>
			<date>20081127110000000</date>
			<duration>3600</duration>
			<priority>2</priority>
			<privacy>0</privacy>
			<attendees>
				<attendee displayName="user3 user3" email="user3@dom1.local" required="CHAIR" state="ACCEPTED"/>
			</attendees>
			<recurrence kind="none"/>
			</event>
		</updated>
	</calendar-changes>
	*/
}

GetSyncEventWithSortedChangesResponseShell.prototype = {
	getUpdatedEvents: function() {
		return this._updated;
	},
	getRemovedEventIds: function() {
		return this._removed;
	},
	getRemovedEventExtIds: function() {
		return this._removedExtId;
	},
	getParticipationChanges: function() {
		return this._participationChanged;
	},
	get lastsync() {
		return this._lastSync;
	}
};

function GetSyncEventResponseShell(aXml) {
	this._updated = [];
	this._removed = [];
	this._removedExtId = [];
	this._lastSync = aXml.@lastSync.toString();

	for each (var updated in aXml.*::updated.*) {
// 	    if ( (updated.*::recurrenceId == undefined) || (updated.*::recurrenceId == 0)) {
		  this._updated.push(new EventShell(updated));
// 		} else {
		  //skip this is an eventException allready in parent item
// 		}
	}

	for each (var removed in aXml.*::removed.*) {
		this._removed.push(removed.@id.toString());
		if (removed.@extId != undefined) {
			this._removedExtId.push(removed.@extId.toString());
		}
	}

	/*
	<calendar-changes lastSync="20081127230000000" xmlns="http://www.obm.org/xsd/sync/calendar-changes.xsd">
		<removed>
			<event id="user3-2" extId="85f148ae-2400-4860-b1dd-ae3fa062b07b"/>
			<event id="user3-3" extId="e1e253f9-b7a6-488b-a360-5ca294afb803"/>
			<event id="user3-4" extId="ad3f09e7-1a5e-40c2-ae1d-12906fbc3760"/>
			<event id="user3-5" extId="e19991ea-8131-4b61-88fe-e25b84311073"/>
		</removed>
		<updated>
			<event id="1">
			<title>eeeeee</title>
			<owner>user3</owner>
			<date>20081127110000000</date>
			<duration>3600</duration>
			<priority>2</priority>
			<privacy>0</privacy>
			<attendees>
				<attendee displayName="user3 user3" email="user3@dom1.local" required="CHAIR" state="ACCEPTED"/>
			</attendees>
			<recurrence kind="none"/>
			</event>
		</updated>
	</calendar-changes>
	*/
}

GetSyncEventResponseShell.prototype = {
	getUpdatedEvents: function() {
		return this._updated;
	},
	getRemovedEventIds: function() {
		return this._removed;
	},
	getRemovedEventExtIds: function() {
		return this._removedExtId;
	},
	get lastsync() {
		return this._lastSync;
	}
};

function GetCategoriesShell(aXml) {
	this._categories = [];
	for each (var xcat in aXml.*::cat) {
		var cat = {
			id : _xL(xcat.@id),
			label : _xS(xcat.@label)
		};
		this._categories.push(cat);
	}
}

GetCategoriesShell.prototype = {

	getCategories: function() {
		return this._categories;
	}
};

