/* ***** BEGIN LICENSE BLOCK *****
 *
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  http://www.obm.org/
 *
 * ***** END LICENSE BLOCK ***** */
/* Calendar Event Synchronizer */

var scriptLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                             .createInstance(Components.interfaces.mozIJSSubScriptLoader);

if ( typeof(Calendar_Base_Synchronizer) == "undefined" ) {
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendar/synchronizer/Calendar_Base_Synchronizer.js");
}

if ( typeof(UtilsOBM) == "undefined" ) {
  scriptLoader.loadSubScript("chrome://obm-extension/content/calendars/UtilsOBM.js");
}

function Calendar_Event_Synchronizer() {
    this.mSupportedItemType = Components.interfaces.calIEvent;
}

Calendar_Event_Synchronizer.prototype = {
  __proto__: new Calendar_Base_Synchronizer(),
  notifyItemAdded: function(aContainer, aItem) {
          this.logger.debug("Event_Synchronizer : notifyItemAdded", false, false);
          if (this.mSynchronizing) {
                  this.logger.debug("mSynchronizing", false, false);
                  return;
          }

          aContainer = aContainer.QueryInterface(this.mSupportedContainerType);

          if (!this.isContainerManagedByOBM(aContainer)) {
                  this.logger.debug("! isContainerManagedByOBM", false, false);
                  return;
          }

          var containerName = this.getContainerOBMName(aContainer);

          var itemID = this.getItemID(aItem);
          var newId = false;
          if (!itemID) {
              // FIXME: in which case there isn't any ID ?? It should be documented.

                  newId = true;
                  // assign an ID to the new created item if necessary
                  // (i.e. address book contact)
                  itemID = "" + Math.round(Math.random() * 1000) + "-" + Math.round(Math.random() * 1000);

                  this.logger.debug("generate itemID:" + itemID, false, false);
                  // FIXME: what is the link between this code and the new event we want to add??
                  // FIXME: related to participants?
                  // FIXME: It should be documented if there is a reason to do that!
                  if (this.mSupportedContainerType == Components.interfaces.nsIAbDirectory && this.abVersion != 3) {
                          this.logger.debug("nsIAbDirectory", false, false);
                          var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
                          var addressBookWindow = windowManager.getMostRecentWindow("mail:addressbook");
                          if (addressBookWindow) {
                                  // XXX selecting the same address book doesn't reload the data!
                                  // re-select the current address book to refresh the view after synchronization
                                  var view = addressBookWindow.document.getElementById("dirTree").view;
                                  view.selection.select(0); //invalidateSelection();
                          }
                  }
          }

          UtilsOBM.addEventToChangesList(aItem,"added");

          //UtilsOBM.addItemToChangesList(this.mSupportedContainerType.toString(), containerName, this.mSupportedItemType.toString(), "added", itemID);
          if (newId) {
                  this.setItemID(aContainer, aItem, itemID);
                  //in tb3 will raise onPropertyChanged of addressbook listenner
                  //so call after pushing in added list
          }
  },

  notifyItemModified: function(aContainer, aItem) {
          this.logger.debug("Event_Synchronizer : notifyItemModified", false, false);
          if (this.mSynchronizing) {
                  this.logger.debug("mSynchronizing", false, false);
                  return;
          }

          aContainer = aContainer.QueryInterface(this.mSupportedContainerType);
          aItem = aItem.QueryInterface(this.mSupportedItemType);

          if (!this.isContainerManagedByOBM(aContainer)) {
                  return;
          }

          var containerName = this.getContainerOBMName(aContainer);

          var itemID = this.getItemID(aItem);
          this.logger.debug("itemID:" + itemID, false, false);
          UtilsOBM.addEventToChangesList(aItem,"updated");
          //UtilsOBM.addItemToChangesList(this.mSupportedContainerType.toString(), containerName, this.mSupportedItemType.toString(), "updated", itemID);
  },

  notifyItemParticipationChanged: function(aContainer, aItem) {
          this.logger.debug("Event_Synchronizer : notifyItemParticipationChanged", false, false);
          if (this.mSynchronizing) {
                  this.logger.debug("mSynchronizing", false, false);
                  return;
          }

          aContainer = aContainer.QueryInterface(this.mSupportedContainerType);
          aItem = aItem.QueryInterface(this.mSupportedItemType);

          if (!this.isContainerManagedByOBM(aContainer)) {
                  return;
          }

          var containerName = this.getContainerOBMName(aContainer);

          var itemID = this.getItemID(aItem);
          this.logger.debug("itemID:" + itemID, false, false);
          UtilsOBM.addEventToChangesList(aItem,"participationChanged");
          //UtilsOBM.addItemToChangesList(this.mSupportedContainerType.toString(), containerName, this.mSupportedItemType.toString(), "participationChanged", itemID);
  },

  notifyItemDeleted: function(aContainer, aItem) {
          this.logger.debug("Event_Synchronizer : notifyItemDeleted", false, false);
          if (this.mSynchronizing) {
                  this.logger.debug("mSynchronizing", false, false);
                  return;
          }

          aContainer = aContainer.QueryInterface(this.mSupportedContainerType);
          aItem = aItem.QueryInterface(this.mSupportedItemType);

          if (!this.isContainerManagedByOBM(aContainer)) {
                  return;
          }

          var containerName = this.getContainerOBMName(aContainer);

          var itemID = this.getItemID(aItem);
          if (!itemID) {
                  return;
          }
          UtilsOBM.addEventToChangesList(aItem,"removed");
          //UtilsOBM.addItemToChangesList(this.mSupportedContainerType.toString(), containerName, this.mSupportedItemType.toString(), "removed", itemID);
  }

};
